globals [
  percent-similar  ;; on the average, what percent of a turtle's neighbors
                   ;; are the same color as that turtle?
  percent-unhappy  ;; what percent of the turtles are unhappy?
  Lmax
  Lcurrent
  wage
  revenue
  wage-change 
]

turtles-own [
 status-need
 status-need-koef
 negative-utility
 debt
 payments
 savings
 did-get-job? ; did get job in this step?
 Lfinal
 employed? ;have been employed in the last step?
]


to setup
  clear-all
  
  random-seed 111
  
  create-turtles number
  [
    ;set status-need 2 * basic-need
    
    set status-need-koef 0
    while [status-need-koef < 1.1]
      [ set status-need-koef 1 + random-normal 3 1 ]
      
    set status-need status-need-koef * basic-need
   
    
    set payments 0    
    set debt 0    
    ; if random 5 = 0 [ set debt abs random-normal 3 * basic-need  basic-need ] 
    
    set savings random 100000
    ;set savings 0
    
    set negative-utility 0
    while [negative-utility < 0.5]
      [ set negative-utility random-normal 5 3 ]
    
    set did-get-job? false
    set employed? false
    ]

  random-seed new-seed
  
  set wage W-external
  set Lmax 14 
  set wage-change 10
  
  do-plots
end

to go

  if w-extern [set wage W-external]
  
  ;update-labourers
   
 
  update-labourers-marginal
  update-employers
 
  
  
  update-globals
  
  tick
  
  do-plots
end

to update-employers
  
 set Lcurrent 0
 ;let LTotal sum [Lfinal] of turtles
 ;ifelse LTotal > Ldemand 
 ;  [ if wage > 2 * basic-need / Lmax [  set wage wage - 10 ] ] ; minimal wage
 ;  [ set wage wage + 10 ]
 
 let Ldemand  start-MR - direction-MR * wage 
 
  let tries structural-unemployment * number
  
  ifelse rand-employ
    [  
      while [ Lcurrent < Ldemand and tries < number ]   
            [ let labourer one-of turtles with [not did-get-job?]
              set Lcurrent Lcurrent + [LFinal] of labourer
              ask labourer [ set did-get-job? true
                   set savings savings + LFinal * wage ]
        
              set tries tries + 1
            ]   
    ]
    [ let employed-labourers sort turtles with [employed?]
      ifelse prefer-workaholics 
        [ set employed-labourers sort-by [[LFinal] of ?1 > [Lfinal] of ?2] employed-labourers ]
        [ set employed-labourers shuffle employed-labourers ]  
      
      while [ length employed-labourers > 0 and Lcurrent < Ldemand ]   
            [ 
              if random-float 1 > kick-of-rate
                [
                let labourer first employed-labourers 
                set Lcurrent Lcurrent + [LFinal] of labourer
                ask labourer [ set did-get-job? true
                     set savings savings + LFinal * wage ]
                set tries tries + 1
                ]
              set employed-labourers remove-item 0 employed-labourers
             ]   
       
       let other-labourers sort turtles with [not did-get-job?]
       ifelse prefer-workaholics 
        [ set other-labourers sort-by [[LFinal] of ?1 > [Lfinal] of ?2] other-labourers ]
        [ set other-labourers shuffle other-labourers ]
        
             
      while [ Lcurrent < Ldemand and tries < number ]   
           [ let labourer first other-labourers 
             set Lcurrent Lcurrent + [LFinal] of labourer
             ask labourer [ set did-get-job? true
                  set savings savings + LFinal * wage ]
       
             set tries tries + 1
             set other-labourers remove-item 0 other-labourers
           ]   
           

     ]

  let wage-optim ( Lcurrent - start-MR ) / ( - direction-MR )
  let new-revenue Lcurrent * ( wage-optim - wage ) + (start-MR - wage-optim) * Lcurrent  / 2
  
  if new-revenue - revenue < 0 [ set wage-change wage-change * -1 ]
  if wage > basic-need / Lmax [  set wage wage + wage-change ] ; minimal wage
  
  
  set revenue new-revenue
  
end   


to update-labourers-marginal

  ;set wage W-external
  
  ask turtles [
   
  ifelse debt > 0 
    [ ifelse debt > basic-need 
      [ set payments basic-need] 
      [ set payments debt] 
    ]
    [ set payments 0]
  
   set savings savings - basic-need - payments
   set debt debt - payments
   
   ifelse savings < 0 
     [ set debt debt - savings 
       set savings 0]
     [ ifelse savings < status-need - basic-need 
       [ set savings savings / 2 ]   
       [ ifelse did-get-job? and ( Lfinal * wage) > status-need and savings >  ( Lfinal * wage) - basic-need 
         [ set savings savings - ( status-need - basic-need ) - 
                         ( ( ( Lfinal * wage) - status-need) - ( ( ( Lfinal * wage) - status-need)  ^ 2  ) / savings ) ]
         [ set savings savings - ( ( status-need - basic-need ) - ( ( status-need - basic-need ) ^ 2) / ( 2 * savings ) )]
      
       ]
     ]

   let LBasic (basic-need + payments) / wage 
   if LBasic > Lmax [set Lbasic Lmax]
   
   let LStatus (status-need - basic-need) / wage
   let Lnotkorig LBasic + LStatus 
      
   let Lkorig 0
   let status-marginal-utility ( ( ( Lkorig + 1 ) / (  LStatus )  ) ^ status-utility  ) - ( (  ( Lkorig ) / (  LStatus ) ) ^ status-utility  )
   ;let status-marginal-utility ( log ( ( Lkorig +  LStatus  + 1 ) / (  LStatus )  )  status-utility  ) - ( log (  ( Lkorig +  LStatus  ) / (  LStatus ) )  status-utility  )
 
    let leisure-marginal-utility ( (( Lmax + LBasic + Lkorig + 1 ) / Lmax ) ^ leisure-utility  ) - ( (  ( Lmax + LBasic + Lkorig ) / Lmax ) ^ leisure-utility )
  ;let leisure-marginal-utility ( ( ( ( Lmax + LBasic +  Lkorig + 1 ) / Lmax ) * ( ( sin (  -( pi / 2) + pi * ( ( Lkorig + 1) / (  LStatus ) ) ^ 0.5 ) ) + 2 ) ) ^ leisure-utility  ) 
   ;            - ( ( ( ( Lmax + LBasic + Lkorig ) / Lmax ) * ( ( sin (  -( pi / 2) + pi * ( ( Lkorig) / (  LStatus ) ) ^ 0.5 ) ) + 2 ) ) ^ leisure-utility )
        
   while [ status-marginal-utility - leisure-marginal-utility >= 0 and LBasic + Lkorig < Lmax]
   [ set Lkorig Lkorig + 1
     set status-marginal-utility ( ( ( Lkorig + 1 ) / (  LStatus )  ) ^ status-utility  ) - ( (  ( Lkorig ) / (  LStatus ) ) ^ status-utility  )
     ;set status-marginal-utility ( log ( ( Lkorig +  LStatus + 1 ) / (  LStatus )  )  status-utility  ) - ( log (  ( Lkorig +  LStatus  ) / (  LStatus ) )  status-utility  )
      
     set leisure-marginal-utility ( (( Lmax + LBasic + Lkorig + 1 ) / Lmax ) ^ leisure-utility  ) - ( (  ( Lmax + LBasic + Lkorig ) / Lmax ) ^ leisure-utility )
     ;set leisure-marginal-utility ( ( ( ( Lmax + LBasic +  Lkorig + 1 ) / Lmax ) * ( ( sin (  -( pi / 2) + pi * ( ( Lkorig + 1) / (  LStatus ) ) ^ 0.5 ) ) + 2 ) ) ^ leisure-utility  ) 
     ;          - ( ( ( ( Lmax + LBasic + Lkorig ) / Lmax ) * ( ( sin ( - ( pi / 2) + pi * ( ( Lkorig) / (  LStatus ) ) ^ 0.5 ) ) + 2 ) ) ^ leisure-utility )
     ;set leisure-marginal-utility ( leisure-utility / ( Lmax + 3 - LBasic - Lkorig ) ) - ( leisure-utility / ( Lmax + 2 - LBasic - Lkorig ) )
   
]
   
   set LFinal LBasic + Lkorig
     
  plot-labour-wage LFinal LBasic Lnotkorig 
   
  ; if did-get-job? and savings > 0 
  ;   [ if random-float 1 < loan-prob 
  ;     [ set debt  debt +  ( 10 * basic-need ) ] ]

   if did-get-job? and savings > 0 
     [ if random-float 1 < loan-prob 
       [ set savings savings - ( 10 * basic-need )
         if savings < 0 
         [ set debt debt - savings 
           set savings 0
         ]
       ] 
     ]
   
   
   set employed? did-get-job?
   set did-get-job? false
   
   
   
  ;; if LBasic > Lmax and Savings <= 0 [die] 

  ]
end

to plot-labour-wage  [LF LB Lnk] ; [LFinal LBasic Lnotkorig]
   setxy ( wage /  wage-range ) * max-pxcor (LB / Lmax ) * max-pycor   
   ask patch-here [set pcolor green]
   if (Lnk / Lmax ) * max-pycor < max-pycor
     [ setxy ( wage /  wage-range ) * max-pxcor (Lnk / Lmax ) * max-pycor   
       ask patch-here [set pcolor red] ]
   
   setxy ( wage /  wage-range ) * max-pxcor (LF / Lmax ) * max-pycor   
   ask patch-here [set pcolor white]
   setxy ( wage /  wage-range ) * max-pxcor ( ( (start-MR - direction-MR * wage) / number ) / Lmax ) * max-pycor   
   ask patch-here [set pcolor blue]
end
   

to update-labourers
  
  ;;set wage 1
  
  ask turtles [

   let LBasic (basic-need + payments) / wage 
   let LStatus (status-need - basic-need) / wage
   let Lnotkorig LBasic + LStatus
   let LNU Lmax - LBasic
   let LStatus-korig LNU * ( 1 - ( negative-utility / (LStatus + negative-utility) ) )
   set LFinal LBasic + LStatus-korig

   
  ;; if LBasic > Lmax and Savings <= 0 [die] 
plot-labour-wage LFinal LBasic Lnotkorig 
  ]
end

to update-globals
end

to-report unemployment
report  count turtles with [ did-get-job? = false ] / number
end

to-report paying
  report count turtles with [ payments > 0 ] / number
end 

to-report average-savings
 report sum [savings] of turtles / number
end

to-report average-debt
 report sum [debt] of turtles / number
end

to-report well-being
  report count turtles with [ savings > 3 * (wage * 14) ] / number
end


to do-plots

  set-current-plot "Sociology"
  set-current-plot-pen "unemployment"
  plot unemployment
  set-current-plot-pen "paying"
  plot paying
  set-current-plot-pen "well-being"
  plot well-being
  
  set-current-plot "Savings and debt"
  set-current-plot-pen "savings"
  plot average-savings
  set-current-plot-pen "debt"
  plot average-debt
  
   set-current-plot "Wage"  
  set-current-plot-pen "wage"
  plot wage 
   set-current-plot-pen "Lcurrent"
  plot ( Lcurrent / number ) * 100

 set-current-plot "Revenue"  
  set-current-plot-pen "revenue"
  plot revenue 



end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  old code
;to plot-labour 
;
;  set wage W-external 
;  ask turtles [
;   
;  set status-need status-need-koef * basic-need
;  
;  let wg 90
;   
;   while [ wg < 2000 ]
;   
;   [
;   
;   set wage wg
;   let LBasic (basic-need + payments) / wage 
;   let LStatus (status-need - basic-need) / wage
;   let Lnotkorig LBasic + LStatus
;   let LNU Lmax - LBasic
;   ;let LNU-norm negative-utility * ( ( ( Lmax / 2 ) - LNU ) / ( Lmax ) ) 
;   ;let LStatus-korig LNU * ( 1 - ( LNU-norm / (LStatus + LNU-norm) ) )
;   
;   ;let LStatus-korig LNU * ( 1 - ( over-status / (LStatus + over-status) ) )
;   let LStatus-korig LNU * ( 1 - ( negative-utility / (LStatus + negative-utility) ) )
;   ;let LStatus-korig LNU * ( 1 - ( 1 / (LStatus + 1) ) )
;   set LFinal LBasic + LStatus-korig
;   
;   setxy ( wage / 2000 ) * max-pxcor (LFinal / Lmax ) * max-pycor   
;   ask patch-here [set pcolor white]
;   setxy ( wage / 2000 ) * max-pxcor (LBasic / Lmax ) * max-pycor   
;   ask patch-here [set pcolor green]
;   setxy ( wage / 2000 ) * max-pxcor (Lnotkorig / Lmax ) * max-pycor   
;   ask patch-here [set pcolor red]
;   set wg wg + 1
;   
;   ]
;   
;  ;; if LBasic > Lmax and Savings <= 0 [die] 
;
;  ]
;end
;
;to plot-labour-marginal
;
;  set wage W-external 
;  ask turtles [
;   
;  set status-need status-need-koef * basic-need
;  
;  let wg 90
;
;   while [ wg <  wage-range ]
;   
;   [
;   
;   set wage wg
;   let LBasic (basic-need + payments) / wage 
;   let LStatus (status-need - basic-need) / wage
;   let Lnotkorig LBasic + LStatus 
;   
;   let Lkorig 0
;   let status-marginal-utility ( ( ( Lkorig + 1 ) / (  LStatus )  ) ^ status-utility  ) - ( (  ( Lkorig ) / (  LStatus ) ) ^ status-utility  )
;  let leisure-marginal-utility ( (( Lmax + LBasic + Lkorig + 1 ) / Lmax ) ^ leisure-utility  ) - ( (  ( Lmax + LBasic + Lkorig ) / Lmax ) ^ leisure-utility )
;   ;let leisure-marginal-utility ( leisure-utility / ( Lmax + 2 - LBasic - Lkorig ) ) - ( leisure-utility / ( Lmax + 1 - LBasic - Lkorig ) )
;   
;     
;   ;show wg
;   ;show Lkorig
;   ;show  status-marginal-utility 
;   ;show leisure-marginal-utility 
;   
;   while [ status-marginal-utility - leisure-marginal-utility >= 0 and LBasic + Lkorig < Lmax]
;   [ set Lkorig Lkorig + 1
;     set status-marginal-utility ( ( ( Lkorig + 1 ) / LStatus ) ^ status-utility  ) - ( ( ( Lkorig ) / LStatus ) ^ status-utility  )
;     set leisure-marginal-utility ( ( ( Lmax + LBasic +  Lkorig + 1 ) / Lmax ) ^ leisure-utility  ) - ( (  ( Lmax + LBasic + Lkorig ) / Lmax ) ^ leisure-utility )
;     ;set leisure-marginal-utility ( leisure-utility / ( Lmax + 3 - LBasic - Lkorig ) ) - ( leisure-utility / ( Lmax + 2 - LBasic - Lkorig ) )
;   
;]
;   
;   set LFinal LBasic + Lkorig
;   
;   setxy ( wage /  wage-range ) * max-pxcor (LFinal / Lmax ) * max-pycor   
;   ask patch-here [set pcolor white]
;   setxy ( wage /  wage-range ) * max-pxcor (LBasic / Lmax ) * max-pycor   
;   ask patch-here [set pcolor green]
;   setxy ( wage /  wage-range ) * max-pxcor (Lnotkorig / Lmax ) * max-pycor   
;   ask patch-here [set pcolor red]
;   setxy ( wage /  wage-range ) * max-pxcor (LFinal / Lmax ) * max-pycor   
;   ask patch-here [set pcolor white]
;   setxy ( wage /  wage-range ) * max-pxcor (LFinal / Lmax ) * max-pycor   
;   ask patch-here [set pcolor white]
;   set wg wg + 1
;   
;   ]
;   
;  ;; if LBasic > Lmax and Savings <= 0 [die] 
;
;  ]
;end

; Copyright 1997 Uri Wilensky. All rights reserved.
; The full copyright notice is in the Information tab.
@#$#@#$#@
GRAPHICS-WINDOW
486
14
1298
447
-1
-1
2.0
1
10
1
1
1
0
1
1
1
0
400
0
200
1
1
1
ticks

PLOT
9
246
258
389
Sociology
time
NIL
0.0
5.0
0.0
1.0
true
false
PENS
"unemployment" 1.0 0 -10899396 true
"paying" 1.0 0 -16777216 true
"well-being" 1.0 0 -955883 true

SLIDER
13
102
225
135
number
number
0
2000
200
1
1
NIL
HORIZONTAL

SLIDER
16
55
127
88
basic-need
basic-need
0
2000
1000
1
1
NIL
HORIZONTAL

BUTTON
45
18
125
51
setup
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

BUTTON
126
18
206
51
go
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL

SLIDER
128
56
344
89
W-external
W-external
1
2000
826
1
1
NIL
HORIZONTAL

SLIDER
12
147
184
180
status-utility
status-utility
0
4
0.85
0.01
1
NIL
HORIZONTAL

SLIDER
11
189
183
222
leisure-utility
leisure-utility
0
4
1.85
0.01
1
NIL
HORIZONTAL

SLIDER
452
530
624
563
start-MR
start-MR
0
2000
2000
1
1
NIL
HORIZONTAL

SLIDER
625
530
797
563
direction-MR
direction-MR
0
1
1
0.01
1
NIL
HORIZONTAL

SLIDER
810
455
982
488
wage-range
wage-range
1
20000
2000
1
1
NIL
HORIZONTAL

PLOT
260
247
460
388
Savings and debt
NIL
NIL
0.0
1000.0
0.0
10.0
true
false
PENS
"savings" 1.0 0 -10899396 true
"debt" 1.0 0 -2674135 true
"wage" 1.0 0 -16777216 true

SWITCH
234
21
343
54
W-extern
W-extern
1
1
-1000

SWITCH
453
493
578
526
rand-employ
rand-employ
1
1
-1000

MONITOR
216
189
273
234
NIL
wage
17
1
11

SLIDER
584
493
697
526
kick-of-rate
kick-of-rate
0
1
0.12
0.01
1
NIL
HORIZONTAL

SLIDER
296
190
468
223
loan-prob
loan-prob
0
1
0.016
0.001
1
NIL
HORIZONTAL

PLOT
9
392
209
542
Wage
NIL
NIL
0.0
10.0
0.0
10.0
true
false
PENS
"default" 1.0 0 -16777216 true
"wage" 1.0 0 -16777216 true
"Lcurrent" 1.0 0 -5825686 true

PLOT
207
392
407
542
Revenue
NIL
NIL
0.0
10.0
0.0
10.0
true
false
PENS
"default" 1.0 0 -16777216 true
"revenue" 1.0 0 -16777216 true

SWITCH
454
457
612
490
prefer-workaholics
prefer-workaholics
0
1
-1000

SLIDER
619
456
807
489
structural-unemployment
structural-unemployment
0
0.5
0.03
0.001
1
NIL
HORIZONTAL

TEXTBOX
709
495
859
523
Fixed parameters for employer.
11
0.0
1

TEXTBOX
351
14
501
56
Switches between externaly fixed wage and wage determined by employer
11
0.0
1

@#$#@#$#@
WHAT IS IT?
-----------

HOW TO USE IT
-------------



THINGS TO NOTICE
----------------


THINGS TO TRY
-------------



EXTENDING THE MODEL
-------------------


NETLOGO FEATURES
----------------



CREDITS AND REFERENCES
----------------------

HOW TO CITE
-----------



COPYRIGHT NOTICE
----------------
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 4.1
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
<experiments>
  <experiment name="wage scan" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="100"/>
    <metric>revenue</metric>
    <metric>start-MR - direction-MR * W-external</metric>
    <metric>Lcurrent / number</metric>
    <metric>average-savings</metric>
    <metric>average-debt</metric>
    <metric>unemployment</metric>
    <metric>paying</metric>
    <metric>well-being</metric>
    <metric>count turtles with [ savings &gt; 10 * status-need ] / number</metric>
    <enumeratedValueSet variable="prefer-workaholics">
      <value value="true"/>
    </enumeratedValueSet>
    <steppedValueSet variable="number" first="100" step="100" last="300"/>
    <enumeratedValueSet variable="W-extern">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="status-utility">
      <value value="0.85"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="direction-MR">
      <value value="1"/>
    </enumeratedValueSet>
    <steppedValueSet variable="loan-prob" first="0" step="0.05" last="0.2"/>
    <enumeratedValueSet variable="kick-of-rate">
      <value value="0.02"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="structural-unemployment">
      <value value="0.03"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="leisure-utility">
      <value value="1.85"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="start-MR">
      <value value="2000"/>
    </enumeratedValueSet>
    <steppedValueSet variable="W-external" first="50" step="10" last="1500"/>
    <enumeratedValueSet variable="basic-need">
      <value value="1000"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="wage-range">
      <value value="2000"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="rand-employ">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="wage scan small" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="100"/>
    <metric>revenue</metric>
    <metric>start-MR - direction-MR * W-external</metric>
    <metric>Lcurrent / number</metric>
    <metric>average-savings</metric>
    <metric>average-debt</metric>
    <metric>unemployment</metric>
    <metric>paying</metric>
    <metric>Ltotal</metric>
    <enumeratedValueSet variable="prefer-workaholics">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number">
      <value value="200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="over-status">
      <value value="11.85"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="W-extern">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="status-utility">
      <value value="0.85"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="direction-MR">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="loan-prob">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="kick-of-rate">
      <value value="0.02"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="structural-unemployment">
      <value value="0.03"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="leisure-utility">
      <value value="1.85"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="start-MR">
      <value value="2000"/>
    </enumeratedValueSet>
    <steppedValueSet variable="W-external" first="50" step="10" last="1500"/>
    <enumeratedValueSet variable="basic-need">
      <value value="1000"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="wage-range">
      <value value="2000"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="rand-employ">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="wage find" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="150"/>
    <metric>wage</metric>
    <metric>revenue</metric>
    <metric>start-MR - direction-MR * W-external</metric>
    <metric>Lcurrent / number</metric>
    <metric>average-savings</metric>
    <metric>average-debt</metric>
    <metric>unemployment</metric>
    <metric>paying</metric>
    <enumeratedValueSet variable="prefer-workaholics">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number">
      <value value="100"/>
      <value value="150"/>
      <value value="175"/>
      <value value="190"/>
      <value value="200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="W-extern">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="status-utility">
      <value value="0.85"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="direction-MR">
      <value value="1"/>
    </enumeratedValueSet>
    <steppedValueSet variable="loan-prob" first="0" step="0.0050" last="0.2"/>
    <enumeratedValueSet variable="kick-of-rate">
      <value value="0.02"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="structural-unemployment">
      <value value="0.03"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="leisure-utility">
      <value value="1.85"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="start-MR">
      <value value="2000"/>
    </enumeratedValueSet>
    <steppedValueSet variable="W-external" first="50" step="10" last="1500"/>
    <enumeratedValueSet variable="basic-need">
      <value value="1000"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="wage-range">
      <value value="2000"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="rand-employ">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
</experiments>
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
